from draw_line import draw_line
from Normalizar import feature_normalize
from PCA import pca
from Project import project_data, recover_data

import numpy as np
import scipy.io as sio
import matplotlib.pyplot as plt


mat_data = sio.loadmat('data1.mat')
X = mat_data['X']

X_norm, mu, sigma = feature_normalize(X)
U, S, V = pca(X_norm)

K = 1
Z = project_data(X_norm, U, K)
X_rec = recover_data(Z, U, K)

plt.figure()
plt.scatter(X_norm[:, 0], X_norm[:, 1], facecolors='none', edgecolors='b')
plt.scatter(X_rec[:, 0], X_rec[:, 1], facecolors='none', edgecolors='r')
for i in range(X_norm.shape[0]):
    draw_line(X_norm[i,:], X_rec[i,:], dash=True)
plt.show()
