from display_data import display_data
import scipy.io as sio
import matplotlib.pyplot as plt
from Normalizar import feature_normalize
from PCA import pca
from Project import project_data, recover_data

mat_data = sio.loadmat('faces.mat')
X = mat_data['X']

X_norm, mu, sigma = feature_normalize(X)

U, S, V = pca(X_norm)

K = 100
Z = project_data(X_norm, U, K)
X_rec = recover_data(Z, U, K)

fig = plt.figure(figsize=(10, 10))
ax1 = fig.add_subplot(1, 2, 1)
display_data(X_norm[1:100,:], axes=ax1)
ax1.set_title('Caras normalizadas')
ax2 = fig.add_subplot(1, 2, 2)
display_data(X_rec[1:100,:], axes=ax2)
ax2.set_title('Caras proyectadas')
plt.show()
