from mpl_toolkits.mplot3d import Axes3D
from matplotlib import cm
import matplotlib.image as mpimg

from k_means_init_centroids import k_means_init_centroids
from run_k_means import run_k_means
import numpy as np
import matplotlib.pyplot as plt

A = mpimg.imread('bird_small.png')

A = A.astype(float)
img_size = A.shape
X = A.reshape([img_size[0] * img_size[1], img_size[2]])
K = 16
max_iters = 10
initial_centroids = k_means_init_centroids(X, K)
[centroids, idx] = run_k_means(X, initial_centroids, max_iters)

sel = np.random.randint(X.shape[0], size=1000)

# Setup Color Palette
color = cm.rainbow(np.linspace(0, 1, K))

#  Visualize the data and centroid memberships in 3D
fig = plt.figure()
ax = fig.add_subplot(111, projection='3d')
ax.scatter(X[sel, 0], X[sel, 1], X[sel, 2], c=color[idx[sel].astype(int), :], marker='o')
ax.set_xlim(0, 1)
ax.set_ylim(0, 1)
ax.set_zlim(0, 1)
plt.title('Pixel dataset plotted in 3D. Color shows centroid memberships')
plt.show()
