from mpl_toolkits.mplot3d import Axes3D
from matplotlib import cm
import matplotlib.image as mpimg

from k_means_init_centroids import k_means_init_centroids
from run_k_means import run_k_means
import numpy as np
import matplotlib.pyplot as plt

A = mpimg.imread('bird_small.png')

A = A.astype(float)
img_size = A.shape
X = A.reshape([img_size[0] * img_size[1], img_size[2]])
K = 16
max_iters = 10
initial_centroids = k_means_init_centroids(X, K)
[centroids, idx] = run_k_means(X, initial_centroids, max_iters)

sel = np.random.randint(X.shape[0], size=1000)

from plot_data_points import plot_data_points
from Normalizar import feature_normalize
from PCA import pca
from Project import project_data, recover_data


# Subtract the mean to use PCA
X_norm, mu, sigma = feature_normalize(X)

# PCA and project the data to 2D
U, S, V = pca(X_norm)
Z = project_data(X_norm, U, 2)

# Plot in 2D
plt.figure()
plot_data_points(Z[sel, ], idx[sel, ], K)
plt.title('Pixel dataset plotted in 2D, using PCA for dimensionality reduction')
plt.show()
